#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include "gen_test_data.h"
#include "lac_param.h"
#include "api.h"

#define NDATA 10

	//generate test data  of pke
	int gendata_pke()
	{
		unsigned char pk[CRYPTO_PUBLICKEYBYTES];
		unsigned char sk[CRYPTO_SECRETKEYBYTES];
		unsigned char m[CRYPTO_BYTES], k2[CRYPTO_BYTES], c[CRYPTO_CIPHERTEXTBYTES];
		unsigned long long c_byts, m_byts=CRYPTO_BYTES, pk_byts, sk_byts;
		int i;
		FILE *fp, *fp2;
		unsigned char       entropy_input[48];

		printf("\ntest data of pke is generated in PKE_VEC_INFO.dat\n");
		fp = fopen("test_data_pke.txt", "w");
		if (fp == NULL)
		{
			return -1;
		}
		fp2 = fopen("PKE_VEC_INFO.dat", "w");
		if (fp2 == NULL)
		{
			return -1;
		}

		for (int i = 0; i < 48; i++)
			entropy_input[i] = i;
		rand_init(entropy_input, 48);
		fprintf(fp, "SEED_L\n");
		fputs("00000030", fp);
		fputs("00000030", fp2);
		fprintf(fp, "\nSEED\n");
		for (i = 0; i < 48; i++) {
			fprintf(fp, "%02x", entropy_input[i]);
			fprintf(fp2, "%02x", entropy_input[i]);
		}
		for (int j = 0; j < NDATA; j++) {
			pke_keygen(pk, &pk_byts, sk, &sk_byts);
			rand_byts(CRYPTO_BYTES, m);
			pke_enc(pk, pk_byts, m, m_byts, c, &c_byts);
			pke_dec(sk, sk_byts, c, c_byts, k2, &m_byts);

			//create kat file
			
			
			//wirte arrays
			
			fprintf(fp, "\nSK_LEN\n");
			fprintf(fp, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp2, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp, "\nSK\n");
			for (i = 0; i < CRYPTO_SECRETKEYBYTES; i++)
			{
				fprintf(fp, "%02x", sk[i]);
				fprintf(fp2, "%02x", sk[i]);
			}

			fprintf(fp, "\nPK_LEN\n");
			fprintf(fp, "%08x", CRYPTO_PUBLICKEYBYTES);
			fprintf(fp2, "%08x", CRYPTO_PUBLICKEYBYTES);
			fprintf(fp, "\nPK\n");
			for (i = 0; i < CRYPTO_PUBLICKEYBYTES; i++)
			{
				fprintf(fp, "%02x", pk[i]);
				fprintf(fp2, "%02x", pk[i]);
			}

			fprintf(fp, "\nM_LEN\n");
			fprintf(fp, "%08x", CRYPTO_BYTES);
			fprintf(fp2, "%08x", CRYPTO_BYTES);
			fprintf(fp, "\nMessage\n");
			for (i = 0; i < CRYPTO_BYTES; i++)
			{
				fprintf(fp, "%02x", m[i]);
				fprintf(fp2, "%02x", m[i]);
			}

			fprintf(fp, "\nC_LEN\n");
			fprintf(fp, "%08x", CRYPTO_CIPHERTEXTBYTES);
			fprintf(fp2, "%08x", CRYPTO_CIPHERTEXTBYTES);
			fprintf(fp, "\nCiphertext\n");
			for (i = 0; i < CRYPTO_CIPHERTEXTBYTES; i++)
			{
				fprintf(fp, "%02x", c[i]);
				fprintf(fp2, "%02x", c[i]);
			}
		}

		fclose(fp);
		fclose(fp2);
		return 0;
	}

	//generate test data of kem
	int gendata_kem()
	{
		unsigned char pk[CRYPTO_PUBLICKEYBYTES];
		unsigned char sk[CRYPTO_SECRETKEYBYTES];
		unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], c[CRYPTO_CIPHERTEXTBYTES];
		unsigned long long pk_byts, sk_byts, ss_byts, c_byts;
		unsigned char       entropy_input[48];
		int i;

		FILE *fp, *fp2;
		//create kat file
		printf("\ntest data of kem is generated in KEM_VEC_INFO.dat\n");
		fp = fopen("test_data_kem.txt", "w");
		if (fp == NULL)
		{
			return -1;
		}
		fp2 = fopen("KEM_VEC_INFO.dat", "w");
		if (fp2 == NULL)
		{
			return -1;
		}

		for (i = 0; i < 48; i++)
			entropy_input[i] = i;
		rand_init(entropy_input, 48);
		

		fprintf(fp, "SEED_L\n");
		fputs("00000030", fp);
		fputs("00000030", fp2);
		fprintf(fp, "\nSEED\n");
		for (i = 0; i < 48; i++) {
			fprintf(fp, "%02x", entropy_input[i]);
			fprintf(fp2, "%02x", entropy_input[i]);
		}
		for (int j = 0; j < NDATA; j++) {
			kem_keygen(pk, &pk_byts, sk, &sk_byts);
			kem_enc(pk, pk_byts, k1, &ss_byts, c, &c_byts);
			kem_dec(sk, sk_byts, c, c_byts, k2, &ss_byts);
			//wirte arrays
			fprintf(fp, "\nSK_LEN\n");
			fprintf(fp, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp2, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp, "\n\nSK\n");
			for (i = 0; i < CRYPTO_SECRETKEYBYTES; i++)
			{
				fprintf(fp, "%02x", sk[i]);
				fprintf(fp2, "%02x", sk[i]);
			}

			fprintf(fp, "\nPK_LEN\n");
			fprintf(fp, "%08x", CRYPTO_PUBLICKEYBYTES);
			fprintf(fp2, "%08x", CRYPTO_PUBLICKEYBYTES);
			fprintf(fp, "PK\n");
			for (i = 0; i < CRYPTO_PUBLICKEYBYTES; i++)
			{
				fprintf(fp, "%02x", pk[i]);
				fprintf(fp2, "%02x", pk[i]);
			}

			fprintf(fp, "\nC_LEN\n");
			fprintf(fp, "%08x", CRYPTO_CIPHERTEXTBYTES);
			fprintf(fp2, "%08x", CRYPTO_CIPHERTEXTBYTES);
			fprintf(fp, "\n\nCiphertext\n");
			for (i = 0; i < CRYPTO_CIPHERTEXTBYTES; i++)
			{
				fprintf(fp, "%02x", c[i]);
				fprintf(fp2, "%02x", c[i]);
			}
			
			fprintf(fp, "\nSession_Key_LEN\n");
			fprintf(fp, "%08x", CRYPTO_BYTES);
			fprintf(fp2, "%08x", CRYPTO_BYTES);
			fprintf(fp, "\n\nSession Key\n");
			for (i = 0; i < CRYPTO_BYTES; i++)
			{
				fprintf(fp, "%02x", k1[i]);
				fprintf(fp2, "%02x", k1[i]);
			}

			
		}

		fclose(fp);
		fclose(fp2);
		return 0;
	}

	//generate test data of ake
	int gendata_ake()
	{
		unsigned char pka[CRYPTO_PUBLICKEYBYTES], pkb[CRYPTO_PUBLICKEYBYTES];
		unsigned char ska[CRYPTO_SECRETKEYBYTES], skb[CRYPTO_SECRETKEYBYTES], pa[CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_BYTES + CRYPTO_CIPHERTEXTBYTES + CRYPTO_PUBLICKEYBYTES], pb[CRYPTO_SECRETKEYBYTES];
		unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], ma[CRYPTO_PUBLICKEYBYTES + CRYPTO_CIPHERTEXTBYTES], mb[CRYPTO_CIPHERTEXTBYTES + CRYPTO_CIPHERTEXTBYTES];
		unsigned long long pka_byts, ska_byts, pkb_byts, skb_byts, pa_byts, pb_byts, ma_byts, mb_byts, k1_byts, k2_byts;
		unsigned char       entropy_input[48];
		int i;

		FILE *fp, *fp2;
		//create kat file
		fp = fopen("test_data_ake.txt", "w");
		printf("\ntest data of ake is generated in AKE_VEC_INFO.dat\n");
		if (fp == NULL)
		{
			return -1;
		}
		fp2 = fopen("AKE_VEC_INFO.dat", "w");
		if (fp2 == NULL)
		{
			return -1;
		}

		for (int i = 0; i < 48; i++)
			entropy_input[i] = i;
		rand_init(entropy_input, 48);
		fprintf(fp, "SEED_L\n");
		fputs("00000030", fp);
		fputs("00000030", fp2);
		fprintf(fp, "\nSEED\n");
		for (i = 0; i < 48; i++) {
			fprintf(fp, "%02x", entropy_input[i]);
			fprintf(fp2, "%02x", entropy_input[i]);
		}

		for (int j = 0; j < NDATA; j++) {

			kex_init_a(pka, &pka_byts, ska, &ska_byts, pa, &pa_byts);
			kex_init_b(pkb, &pkb_byts, skb, &skb_byts, pb, &pb_byts);
			

			//wirte arrays
			fprintf(fp, "\nAlice_SK_LEN\n");
			fprintf(fp, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp2, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp, "\nkex_init_a ska\n");
			for (i = 0; i < CRYPTO_SECRETKEYBYTES; i++)
			{
				fprintf(fp, "%02x", ska[i]);
				fprintf(fp2, "%02x", ska[i]);
			}

			fprintf(fp, "\nAlice_PK_LEN\n");
			fprintf(fp, "%08x", CRYPTO_PUBLICKEYBYTES);
			fprintf(fp2, "%08x", CRYPTO_PUBLICKEYBYTES);
			fprintf(fp, "\nkex_init_a pka\n");
			for (i = 0; i < CRYPTO_PUBLICKEYBYTES; i++)
			{
				fprintf(fp, "%02x", pka[i]);
				fprintf(fp2, "%02x", pka[i]);
			}


			fprintf(fp, "\nBob_SK_LEN\n");
			fprintf(fp, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp2, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp, "\nkex_init_b skb\n");
			for (i = 0; i < CRYPTO_SECRETKEYBYTES; i++)
			{
				fprintf(fp, "%02x", skb[i]);
				fprintf(fp2, "%02x", skb[i]);
			}

			fprintf(fp, "\nBob_PK_LEN\n");
			fprintf(fp, "%08x", CRYPTO_PUBLICKEYBYTES);
			fprintf(fp2, "%08x", CRYPTO_PUBLICKEYBYTES);
			fprintf(fp, "\nkex_init_b pkb\n");
			for (i = 0; i < CRYPTO_PUBLICKEYBYTES; i++)
			{
				fprintf(fp, "%02x", pkb[i]);
				fprintf(fp2, "%02x", pkb[i]);
			}

			fprintf(fp, "\nkex_init_a pa_len\n");
			fprintf(fp, "%08x", CRYPTO_SECRETKEYBYTES);//pa=ska
			fprintf(fp2, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp, "\nkex_init_a pa\n");
			for (i = 0; i < CRYPTO_SECRETKEYBYTES; i++)
			{
				fprintf(fp, "%02x", pa[i]);
				fprintf(fp2, "%02x", pa[i]);
			}


			fprintf(fp, "\nkex_init_b pb_len\n");
			fprintf(fp, "%08x", CRYPTO_SECRETKEYBYTES);//pb=skb
			fprintf(fp2, "%08x", CRYPTO_SECRETKEYBYTES);
			fprintf(fp, "\nkex_init_b pb\n");
			for (i = 0; i < CRYPTO_SECRETKEYBYTES; i++)
			{
				fprintf(fp, "%02x", pb[i]);
				fprintf(fp2, "%02x", pb[i]);
			}

			kex_send_a(pkb, pkb_byts, pa, &pa_byts, ma, &ma_byts);
			
			
			fprintf(fp, "\nkex_send_a pa_len\n");
			fprintf(fp, "%08x", pa_byts);
			fprintf(fp2, "%08x", pa_byts);
			fprintf(fp, "\nkex_send_a pa\n");
			for (i = 0; i < pa_byts; i++)
			{
				fprintf(fp, "%02x", pa[i]);
				fprintf(fp2, "%02x", pa[i]);
			}

			fprintf(fp, "\nkex_send_a ma_len\n");
			fprintf(fp, "%08x", ma_byts);
			fprintf(fp2, "%08x", ma_byts);
			fprintf(fp, "\nkex_send_a ma\n");
			for (i = 0; i < ma_byts; i++)
			{
				fprintf(fp, "%02x", ma[i]);
				fprintf(fp2, "%02x", ma[i]);
			}

			kex_send_b(pka, pka_byts, ma, ma_byts, pb, &pb_byts, mb, &mb_byts, k1, &k1_byts);
			

			fprintf(fp, "\nkex_send_b pb_len\n");

			fprintf(fp, "%08x", pb_byts);
			fprintf(fp2, "%08x", pb_byts);
			fprintf(fp, "\nkex_send_b pb\n");
			for (i = 0; i < pb_byts; i++)
			{
				fprintf(fp, "%02x", pb[i]);
				fprintf(fp2, "%02x", pb[i]);
			}

			fprintf(fp, "\nkex_send_b mb_len\n");
			fprintf(fp, "%08x", mb_byts);
			fprintf(fp2, "%08x", mb_byts);
			fprintf(fp, "\nkex_send_b mb\n");
			for (i = 0; i < mb_byts; i++)
			{
				fprintf(fp, "%02x", mb[i]);
				fprintf(fp2, "%02x", mb[i]);
			}

			kex_resp_a(mb, mb_byts, pa, &pa_byts, ma, &ma_byts, k2, &k2_byts);
			fprintf(fp, "\nkex_resp_a len\n");
			fprintf(fp, "00000000");
			fprintf(fp2, "00000000");

			fprintf(fp, "\nsession_key_len\n");
			fprintf(fp, "%08x", CRYPTO_BYTES);
			fprintf(fp2, "%08x", CRYPTO_BYTES);
			fprintf(fp, "\nsession_key\n");
			for (i = 0; i < CRYPTO_BYTES; i++)
			{
				fprintf(fp, "%02x", k2[i]);
				fprintf(fp2, "%02x", k2[i]);
			}
			
		}

		fclose(fp);
		fclose(fp2);
		return 0;
	}
